package/liberation: fix download site due to recent fedorahosted.org closing
[buildroot-gz.git] / toolchain / helpers.mk
blob2f73ebbe8bb370c4edb80308f46729bfa97265e4
1 # This Makefile fragment declares toolchain related helper functions.
3 # The copy_toolchain_lib_root function copies a toolchain library and
4 # its symbolic links from the sysroot directory to the target
5 # directory. Note that this function is used both by the external
6 # toolchain logic, and the glibc package, so care must be taken when
7 # changing this function.
9 # $1: library name
11 copy_toolchain_lib_root = \
12 LIB="$(strip $1)"; \
14 LIBPATHS=`find $(STAGING_DIR)/ -name "$${LIB}" 2>/dev/null` ; \
15 for LIBPATH in $${LIBPATHS} ; do \
16 DESTDIR=`echo $${LIBPATH} | sed "s,^$(STAGING_DIR)/,," | xargs dirname` ; \
17 mkdir -p $(TARGET_DIR)/$${DESTDIR}; \
18 while true ; do \
19 LIBNAME=`basename $${LIBPATH}`; \
20 LIBDIR=`dirname $${LIBPATH}` ; \
21 LINKTARGET=`readlink $${LIBPATH}` ; \
22 rm -fr $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
23 if test -h $${LIBPATH} ; then \
24 ln -sf `basename $${LINKTARGET}` $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME} ; \
25 elif test -f $${LIBPATH}; then \
26 $(INSTALL) -D -m0755 $${LIBPATH} $(TARGET_DIR)/$${DESTDIR}/$${LIBNAME}; \
27 else \
28 exit -1; \
29 fi; \
30 if test -z "$${LINKTARGET}" ; then \
31 break ; \
32 fi ; \
33 LIBPATH="`readlink -f $${LIBPATH}`"; \
34 done; \
35 done
38 # Copy the full external toolchain sysroot directory to the staging
39 # dir. The operation of this function is rendered a little bit
40 # complicated by the support for multilib toolchains.
42 # We start by copying etc, lib, sbin and usr from the sysroot of the
43 # selected architecture variant (as pointed by ARCH_SYSROOT_DIR). This
44 # allows to import into the staging directory the C library and
45 # companion libraries for the correct architecture variant. We
46 # explictly only copy etc, lib, sbin and usr since other directories
47 # might exist for other architecture variants (on Codesourcery
48 # toolchain, the sysroot for the default architecture variant contains
49 # the armv4t and thumb2 subdirectories, which are the sysroot for the
50 # corresponding architecture variants), and we don't want to import
51 # them.
53 # Then, if the selected architecture variant is not the default one
54 # (i.e, if SYSROOT_DIR != ARCH_SYSROOT_DIR), then we :
56 # * Import the header files from the default architecture
57 # variant. Header files are typically shared between the sysroots
58 # for the different architecture variants. If we use the
59 # non-default one, header files were not copied by the previous
60 # step, so we copy them here from the sysroot of the default
61 # architecture variant.
63 # * Create a symbolic link that matches the name of the subdirectory
64 # for the architecture variant in the original sysroot. This is
65 # required as the compiler will by default look in
66 # sysroot_dir/arch_variant/ for libraries and headers, when the
67 # non-default architecture variant is used. Without this, the
68 # compiler fails to find libraries and headers.
70 # Some toolchains (i.e Linaro binary toolchains) store support
71 # libraries (libstdc++, libgcc_s) outside of the sysroot, so we simply
72 # copy all the libraries from the "support lib directory" into our
73 # sysroot.
75 # Note that the 'locale' directories are not copied. They are huge
76 # (400+MB) in CodeSourcery toolchains, and they are not really useful.
78 # $1: main sysroot directory of the toolchain
79 # $2: arch specific sysroot directory of the toolchain
80 # $3: arch specific subdirectory in the sysroot
81 # $4: directory of libraries ('lib', 'lib32' or 'lib64')
82 # $5: support lib directories (for toolchains storing libgcc_s,
83 # libstdc++ and other gcc support libraries outside of the
84 # sysroot)
85 copy_toolchain_sysroot = \
86 SYSROOT_DIR="$(strip $1)"; \
87 ARCH_SYSROOT_DIR="$(strip $2)"; \
88 ARCH_SUBDIR="$(strip $3)"; \
89 ARCH_LIB_DIR="$(strip $4)" ; \
90 SUPPORT_LIB_DIR="$(strip $5)" ; \
91 for i in etc $${ARCH_LIB_DIR} sbin usr usr/$${ARCH_LIB_DIR}; do \
92 if [ ! -d $${ARCH_SYSROOT_DIR}/$$i ] ; then \
93 continue ; \
94 fi ; \
95 rsync -au --chmod=u=rwX,go=rX --exclude 'locale/' \
96 --include '/libexec*/' --exclude '/lib*/' \
97 $${ARCH_SYSROOT_DIR}/$$i/ $(STAGING_DIR)/$$i/ ; \
98 done ; \
99 if [ `readlink -f $${SYSROOT_DIR}` != `readlink -f $${ARCH_SYSROOT_DIR}` ] ; then \
100 if [ ! -d $${ARCH_SYSROOT_DIR}/usr/include ] ; then \
101 cp -a $${SYSROOT_DIR}/usr/include $(STAGING_DIR)/usr ; \
102 fi ; \
103 mkdir -p `dirname $(STAGING_DIR)/$${ARCH_SUBDIR}` ; \
104 relpath="./" ; \
105 nbslashs=`printf $${ARCH_SUBDIR} | sed 's%[^/]%%g' | wc -c` ; \
106 for slash in `seq 1 $${nbslashs}` ; do \
107 relpath=$${relpath}"../" ; \
108 done ; \
109 ln -s $${relpath} $(STAGING_DIR)/$${ARCH_SUBDIR} ; \
110 echo "Symlinking $(STAGING_DIR)/$${ARCH_SUBDIR} -> $${relpath}" ; \
111 fi ; \
112 if test -n "$${SUPPORT_LIB_DIR}" ; then \
113 cp -a $${SUPPORT_LIB_DIR}/* $(STAGING_DIR)/lib/ ; \
114 fi ; \
115 find $(STAGING_DIR) -type d | xargs chmod 755
118 # Check the specified kernel headers version actually matches the
119 # version in the toolchain.
121 # $1: sysroot directory
122 # $2: kernel version string, in the form: X.Y
124 check_kernel_headers_version = \
125 if ! support/scripts/check-kernel-headers.sh $(1) $(2); then \
126 exit 1; \
130 # Check the specific gcc version actually matches the version in the
131 # toolchain
133 # $1: path to gcc
134 # $2: expected gcc version
136 check_gcc_version = \
137 expected_version="$(strip $2)" ; \
138 if [ -z "$${expected_version}" ]; then \
139 exit 0 ; \
140 fi; \
141 real_version=`$(1) -dumpversion` ; \
142 if [[ ! "$${real_version}" =~ ^$${expected_version}\. ]] ; then \
143 printf "Incorrect selection of gcc version: expected %s.x, got %s\n" \
144 "$${expected_version}" "$${real_version}" ; \
145 exit 1 ; \
149 # Check the availability of a particular glibc feature. This function
150 # is used to check toolchain options that are always supported by
151 # glibc, so we simply check that the corresponding option is properly
152 # enabled.
154 # $1: Buildroot option name
155 # $2: feature description
157 check_glibc_feature = \
158 if [ "$($(1))" != "y" ] ; then \
159 echo "$(2) available in C library, please enable $(1)" ; \
160 exit 1 ; \
164 # Check the availability of RPC support in a glibc toolchain
166 # $1: sysroot directory
168 check_glibc_rpc_feature = \
169 IS_IN_LIBC=`test -f $(1)/usr/include/rpc/rpc.h && echo y` ; \
170 if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
171 echo "RPC support available in C library, please enable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
172 exit 1 ; \
173 fi ; \
174 if [ "$(BR2_TOOLCHAIN_HAS_NATIVE_RPC)" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
175 echo "RPC support not available in C library, please disable BR2_TOOLCHAIN_EXTERNAL_INET_RPC" ; \
176 exit 1 ; \
180 # Check the correctness of a glibc external toolchain configuration.
181 # 1. Check that the C library selected in Buildroot matches the one
182 # of the external toolchain
183 # 2. Check that all the C library-related features are enabled in the
184 # config, since glibc always supports all of them
186 # $1: sysroot directory
188 check_glibc = \
189 SYSROOT_DIR="$(strip $1)"; \
190 if test `find $${SYSROOT_DIR}/ -maxdepth 2 -name 'ld-linux*.so.*' -o -name 'ld.so.*' -o -name 'ld64.so.*' | wc -l` -eq 0 ; then \
191 echo "Incorrect selection of the C library"; \
192 exit -1; \
193 fi; \
194 $(call check_glibc_feature,BR2_USE_MMU,MMU support) ;\
195 $(call check_glibc_rpc_feature,$${SYSROOT_DIR})
198 # Check that the selected C library really is musl
200 # $1: sysroot directory
201 check_musl = \
202 SYSROOT_DIR="$(strip $1)"; \
203 if test ! -f $${SYSROOT_DIR}/lib/libc.so -o -e $${SYSROOT_DIR}/lib/libm.so ; then \
204 echo "Incorrect selection of the C library" ; \
205 exit -1; \
209 # Check the conformity of Buildroot configuration with regard to the
210 # uClibc configuration of the external toolchain, for a particular
211 # feature.
213 # If 'Buildroot option name' ($2) is empty it means the uClibc option
214 # is mandatory.
216 # $1: uClibc macro name
217 # $2: Buildroot option name
218 # $3: uClibc config file
219 # $4: feature description
221 check_uclibc_feature = \
222 IS_IN_LIBC=`grep -q "\#define $(1) 1" $(3) && echo y` ; \
223 if [ -z "$(2)" ] ; then \
224 if [ "$${IS_IN_LIBC}" != "y" ] ; then \
225 echo "$(4) not available in C library, toolchain unsuitable for Buildroot" ; \
226 exit 1 ; \
227 fi ; \
228 else \
229 if [ "$($(2))" != "y" -a "$${IS_IN_LIBC}" = "y" ] ; then \
230 echo "$(4) available in C library, please enable $(2)" ; \
231 exit 1 ; \
232 fi ; \
233 if [ "$($(2))" = "y" -a "$${IS_IN_LIBC}" != "y" ] ; then \
234 echo "$(4) not available in C library, please disable $(2)" ; \
235 exit 1 ; \
236 fi ; \
240 # Check the correctness of a uclibc external toolchain configuration
241 # 1. Check that the C library selected in Buildroot matches the one
242 # of the external toolchain
243 # 2. Check that the features enabled in the Buildroot configuration
244 # match the features available in the uClibc of the external
245 # toolchain
247 # $1: sysroot directory
249 check_uclibc = \
250 SYSROOT_DIR="$(strip $1)"; \
251 if ! test -f $${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; then \
252 echo "Incorrect selection of the C library"; \
253 exit -1; \
254 fi; \
255 UCLIBC_CONFIG_FILE=$${SYSROOT_DIR}/usr/include/bits/uClibc_config.h ; \
256 $(call check_uclibc_feature,__ARCH_USE_MMU__,BR2_USE_MMU,$${UCLIBC_CONFIG_FILE},MMU support) ;\
257 $(call check_uclibc_feature,__UCLIBC_HAS_LFS__,,$${UCLIBC_CONFIG_FILE},Large file support) ;\
258 $(call check_uclibc_feature,__UCLIBC_HAS_IPV6__,,$${UCLIBC_CONFIG_FILE},IPv6 support) ;\
259 $(call check_uclibc_feature,__UCLIBC_HAS_RPC__,BR2_TOOLCHAIN_HAS_NATIVE_RPC,$${UCLIBC_CONFIG_FILE},RPC support) ;\
260 $(call check_uclibc_feature,__UCLIBC_HAS_LOCALE__,BR2_ENABLE_LOCALE,$${UCLIBC_CONFIG_FILE},Locale support) ;\
261 $(call check_uclibc_feature,__UCLIBC_HAS_WCHAR__,BR2_USE_WCHAR,$${UCLIBC_CONFIG_FILE},Wide char support) ;\
262 $(call check_uclibc_feature,__UCLIBC_HAS_THREADS__,BR2_TOOLCHAIN_HAS_THREADS,$${UCLIBC_CONFIG_FILE},Thread support) ;\
263 $(call check_uclibc_feature,__PTHREADS_DEBUG_SUPPORT__,BR2_TOOLCHAIN_HAS_THREADS_DEBUG,$${UCLIBC_CONFIG_FILE},Thread debugging support) ;\
264 $(call check_uclibc_feature,__UCLIBC_HAS_THREADS_NATIVE__,BR2_TOOLCHAIN_HAS_THREADS_NPTL,$${UCLIBC_CONFIG_FILE},NPTL thread support)
267 # Check that the Buildroot configuration of the ABI matches the
268 # configuration of the external toolchain.
270 # $1: cross-gcc path
271 # $2: cross-readelf path
273 check_arm_abi = \
274 __CROSS_CC=$(strip $1) ; \
275 __CROSS_READELF=$(strip $2) ; \
276 EXT_TOOLCHAIN_TARGET=`LANG=C $${__CROSS_CC} -v 2>&1 | grep ^Target | cut -f2 -d ' '` ; \
277 if ! echo $${EXT_TOOLCHAIN_TARGET} | grep -qE 'eabi(hf)?$$' ; then \
278 echo "External toolchain uses the unsuported OABI" ; \
279 exit 1 ; \
280 fi ; \
281 if ! echo 'int main(void) {}' | $${__CROSS_CC} -x c -o $(BUILD_DIR)/.br-toolchain-test.tmp - ; then \
282 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*; \
283 abistr_$(BR2_ARM_EABI)='EABI'; \
284 abistr_$(BR2_ARM_EABIHF)='EABIhf'; \
285 echo "Incorrect ABI setting: $${abistr_y} selected, but toolchain is incompatible"; \
286 exit 1 ; \
287 fi ; \
288 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*
291 # Check that the external toolchain supports C++
293 # $1: cross-g++ path
295 check_cplusplus = \
296 __CROSS_CXX=$(strip $1) ; \
297 $${__CROSS_CXX} -v > /dev/null 2>&1 ; \
298 if test $$? -ne 0 ; then \
299 echo "C++ support is selected but is not available in external toolchain" ; \
300 exit 1 ; \
305 # Check that the external toolchain supports Fortran
307 # $1: cross-gfortran path
309 check_fortran = \
310 __CROSS_FC=$(strip $1) ; \
311 __o=$(BUILD_DIR)/.br-toolchain-test-fortran.tmp ; \
312 printf 'program hello\n\tprint *, "Hello Fortran!\\n"\nend program hello\n' | \
313 $${__CROSS_FC} -x f95 -o $${__o} - ; \
314 if test $$? -ne 0 ; then \
315 rm -f $${__o}* ; \
316 echo "Fortran support is selected but is not available in external toolchain" ; \
317 exit 1 ; \
318 fi ; \
319 rm -f $${__o}* \
322 # Check that the cross-compiler given in the configuration exists
324 # $1: cross-gcc path
326 check_cross_compiler_exists = \
327 __CROSS_CC=$(strip $1) ; \
328 $${__CROSS_CC} -v > /dev/null 2>&1 ; \
329 if test $$? -ne 0 ; then \
330 echo "Cannot execute cross-compiler '$${__CROSS_CC}'" ; \
331 exit 1 ; \
335 # Check for toolchains known not to work with Buildroot.
336 # - For the Angstrom toolchains, we check by looking at the vendor part of
337 # the host tuple.
338 # - Exclude distro-class toolchains which are not relocatable.
339 # - Exclude broken toolchains which return "libc.a" with -print-file-name.
340 # - Exclude toolchains which doesn't support --sysroot option.
342 # $1: cross-gcc path
344 check_unusable_toolchain = \
345 __CROSS_CC=$(strip $1) ; \
346 vendor=`$${__CROSS_CC} -dumpmachine | cut -f2 -d'-'` ; \
347 if test "$${vendor}" = "angstrom" ; then \
348 echo "Angstrom toolchains are not pure toolchains: they contain" ; \
349 echo "many other libraries than just the C library, which makes" ; \
350 echo "them unsuitable as external toolchains for build systems" ; \
351 echo "such as Buildroot." ; \
352 exit 1 ; \
353 fi; \
354 with_sysroot=`$${__CROSS_CC} -v 2>&1 |sed -r -e '/.* --with-sysroot=([^[:space:]]+)[[:space:]].*/!d; s//\1/'`; \
355 if test "$${with_sysroot}" = "/" ; then \
356 echo "Distribution toolchains are unsuitable for use by Buildroot," ; \
357 echo "as they were configured in a way that makes them non-relocatable,"; \
358 echo "and contain a lot of pre-built libraries that would conflict with"; \
359 echo "the ones Buildroot wants to build."; \
360 exit 1; \
361 fi; \
362 libc_a_path=`$${__CROSS_CC} -print-file-name=libc.a` ; \
363 if test "$${libc_a_path}" = "libc.a" ; then \
364 echo "Unable to detect the toolchain sysroot, Buildroot cannot use this toolchain." ; \
365 exit 1 ; \
366 fi ; \
367 sysroot_dir="$(call toolchain_find_sysroot,$${__CROSS_CC})" ; \
368 if test -z "$${sysroot_dir}" ; then \
369 echo "External toolchain doesn't support --sysroot. Cannot use." ; \
370 exit 1 ; \
374 # Check if the toolchain has SSP (stack smashing protector) support
376 # $1: cross-gcc path
378 check_toolchain_ssp = \
379 __CROSS_CC=$(strip $1) ; \
380 __HAS_SSP=`echo 'void main(){}' | $${__CROSS_CC} -fstack-protector -x c - -o $(BUILD_DIR)/.br-toolchain-test.tmp >/dev/null 2>&1 && echo y` ; \
381 if [ "$(BR2_TOOLCHAIN_HAS_SSP)" != "y" -a "$${__HAS_SSP}" = "y" ] ; then \
382 echo "SSP support available in this toolchain, please enable BR2_TOOLCHAIN_EXTERNAL_HAS_SSP" ; \
383 exit 1 ; \
384 fi ; \
385 if [ "$(BR2_TOOLCHAIN_HAS_SSP)" = "y" -a "$${__HAS_SSP}" != "y" ] ; then \
386 echo "SSP support not available in this toolchain, please disable BR2_TOOLCHAIN_EXTERNAL_HAS_SSP" ; \
387 exit 1 ; \
388 fi ; \
389 rm -f $(BUILD_DIR)/.br-toolchain-test.tmp*
392 # Generate gdbinit file for use with Buildroot
394 gen_gdbinit_file = \
395 mkdir -p $(STAGING_DIR)/usr/share/buildroot/ ; \
396 echo "set sysroot $(STAGING_DIR)" > $(STAGING_DIR)/usr/share/buildroot/gdbinit